# ⏯️ AudioCard

⏯️ AudioCard is an opinionated, responsive, audio player for React, designed to be compatible with [Twitter Player Cards](https://developer.twitter.com/en/docs/tweets/optimize-with-cards/overview/player-card.html).

![Screenshot](screenshot.jpg)

## Usage

```bash
yarn add audiocard
```

```jsx
<AudioCard
  art="https://seekjustice.fm/art300.jpg"
  source="https://dts.podtrac.com/redirect.mp3/seekjustice.fm/media/001.mp3"
/>
```

See the other options on the [⏯️ AudioCard Storybook](https://erikras.github.io/audiocard/).

## Acknowledgements

The design was heavily influenced by the Twitter card for [Overcast.fm](https://overcast.fm).

## Contributors

AudioCard is made with ❤️ thanks to these wonderful people ([emoji key](https://github.com/kentcdodds/all-contributors#emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore -->
<table><tr><td align="center"><a href="https://github.com/erikras"><img src="https://avatars1.githubusercontent.com/u/4396759?v=4" width="100px;" alt="Erik Rasmussen"/><br /><sub><b>Erik Rasmussen</b></sub></a><br /><a href="https://github.com/erikras/audiocard/commits?author=erikras" title="Code">💻</a> <a href="#design-erikras" title="Design">🎨</a> <a href="https://github.com/erikras/audiocard/commits?author=erikras" title="Documentation">📖</a> <a href="#example-erikras" title="Examples">💡</a> <a href="#ideas-erikras" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/erikras/audiocard/commits?author=erikras" title="Tests">⚠️</a></td></tr></table>

<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the
[all-contributors](https://github.com/kentcdodds/all-contributors)
specification. Contributions of any kind welcome!
